unit fClientForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls,
  uROClient, uROClientIntf, uRORemoteService, uROJSONMessage, uROIndyTCPChannel, ComCtrls,
  NewLibrary_Intf, uROAsync, uROBaseHTTPClient,
  uROIndyHTTPWebsocketChannel,
  uROIndyHTTPChannel, uROEventRepository, uROBinMessage;

type
  TClientForm = class(TForm,
                      INewEventSink)
    ROMessage: TROJSONMessage;
    ROChannel: TROIndyTCPChannel;
    RORemoteService: TRORemoteService;
    Button1: TButton;
    btnServertime: TButton;
    ProgressBar1: TProgressBar;
    ROIndyHTTPChannel1: TROIndyHTTPChannel;
    Button2: TButton;
    ROEventReceiver1: TROEventReceiver;
    ROBinMessage1: TROBinMessage;
    Button3: TButton;
    Button4: TButton;
    procedure Button1Click(Sender: TObject);
    procedure btnServertimeClick(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
  private
    FROIndyHTTPChannel_Websocket: TROIndyHTTPWebsocketChannel;
    //FChannel: TROWebsocketChannel;
    //FPending: INewService_Async;
    //procedure WebSocketConnectionDataFull(aSender: TWebSocketCustomConnection; aCode: integer; aData: TMemoryStream);
    //procedure ServerAfterAddConnection(Server: TCustomServer; aConnection: TCustomConnection);
    //procedure CustomDataReceived(aData: TMemoryStream);
  protected
    {INewEventSink}
    procedure NewMethod(const NewParam: AnsiString);
    procedure ProgressEvent(const aProgress: Integer; const aMax: Integer);
    procedure TimerEvent(const aTime: DateTime);
  public
    procedure AfterConstruction; override;
  end;

  {TODO -oAM -cGeneral : test ping/pong}

var
  ClientForm: TClientForm;

implementation

uses
  IdHTTP, IdIOHandlerWebsocket, NewLibrary_Async;

{
  The unit NewLibrary_Intf.pas will be generated by the RemObjects preprocessor the first time you
  compile your server application. Make sure to do that before trying to compile the client.

  To invoke your server simply typecast your server to the name of the service interface like this:

      (RORemoteService as INewService).Sum(1,2)
}

{$R *.dfm}

procedure TClientForm.Button1Click(Sender: TObject);
var
  i: Integer;
begin
  {
  if FChannel = nil then FChannel := TROWebsocketChannel.Create(Self);
  FChannel.Host := 'localhost';
  //FChannel.Port := 7000;
  FChannel.Port := 8099;
  FChannel.OnCustomData := Self.CustomDataReceived;
  RORemoteService.Channel := FChannel;
  }
  try
    i := (RORemoteService as INewService).Sum(1,2);
    ShowMessage('Sum of 1 and 2 is: ' + IntToStr(i));
  except
    on e:exception do
      ShowMessage(e.message);
  end;
end;

var
  FROIndyHTTPChannel_Websocket2: TROIndyHTTPWebsocketChannel;

procedure TClientForm.Button2Click(Sender: TObject);
begin
  if FROIndyHTTPChannel_Websocket <> nil then
  begin
    with (FROIndyHTTPChannel_Websocket.IndyClient.IOHandler as TIdIOHandlerWebsocket) do
    begin
      CloseCode   := C_FrameClose_Normal;
      CloseReason := 'Test close';
      Close;
    end;
  end;

//  TMultiChannelReadThread.Instance.BreakSelectWait;

//  if FROIndyHTTPChannel_Websocket2 = nil then
//  begin
//    FROIndyHTTPChannel_Websocket2 := TROIndyHTTPChannel_Websocket.Create(Self);
//    FROIndyHTTPChannel_Websocket2.Host := 'echo.websocket.org';    //ws://echo.websocket.org
//    FROIndyHTTPChannel_Websocket2.Port := 80;
//    FROIndyHTTPChannel_Websocket2.UpgradeToWebsocket;
//  end;
end;

var
  async: INewService_Async;

procedure TClientForm.Button3Click(Sender: TObject);
begin
  async := CoNewService_Async.Create(Self.ROBinMessage1, FROIndyHTTPChannel_Websocket);
  async.Invoke_ExecuteLongStatementWithProgress;
  //(RORemoteService as INewService).ExecuteLongStatementWithProgress;
end;

procedure TClientForm.Button4Click(Sender: TObject);
begin
  (RORemoteService as INewService).StartTimer;
end;

procedure TClientForm.NewMethod(const NewParam: AnsiString);
begin
  ShowMessage(string(NewParam));
end;

procedure TClientForm.ProgressEvent(const aProgress, aMax: Integer);
begin
  ProgressBar1.Max      := aMax;
  ProgressBar1.Position := aProgress;
  ProgressBar1.Update;
end;

procedure TClientForm.TimerEvent(const aTime: DateTime);
begin
  btnServertime.Caption := DateTimeToStr(aTime);
end;

procedure TClientForm.AfterConstruction;
begin
  inherited;

  if FROIndyHTTPChannel_Websocket = nil then
  begin
    FROIndyHTTPChannel_Websocket := TROIndyHTTPWebsocketChannel.Create(Self);
    FROIndyHTTPChannel_Websocket.Host := 'localhost';
    FROIndyHTTPChannel_Websocket.Port := 8099;
    FROIndyHTTPChannel_Websocket.KeepAlive := True;
    //FROIndyHTTPChannel_Websocket.UpgradeToWebsocket;

    ROEventReceiver1.Channel     := FROIndyHTTPChannel_Websocket;
    ROEventReceiver1.Message     := ROBinMessage1;
    //ROEventReceiver1.ServiceName := NewLibrary_Intf.EID_NewEventSink;
    ROEventReceiver1.ServiceName := 'dummy';
    ROEventReceiver1.RegisterEventHandlers([NewLibrary_Intf.EID_NewEventSink], [Self]);
    ROEventReceiver1.SynchronizeInvoke := True;
    ROEventReceiver1.Activate;
  end;
  RORemoteService.Channel := FROIndyHTTPChannel_Websocket;
end;

procedure TClientForm.btnServertimeClick(Sender: TObject);
//var
  //pending: INewService_Async;
  //async: IROAsyncInterface;
//  i: Integer;
begin
  if FROIndyHTTPChannel_Websocket2 = nil then
  begin
    FROIndyHTTPChannel_Websocket2 := TROIndyHTTPWebsocketChannel.Create(Self);
    FROIndyHTTPChannel_Websocket2.Host := 'localhost';
    FROIndyHTTPChannel_Websocket2.Port := 8098;
  end;

//  if FChannel = nil then FChannel := TROWebsocketChannel.Create(Self);
//  FChannel.Host := 'localhost';
//  FChannel.Port := 7000;
//  FChannel.OnCustomData := Self.CustomDataReceived;

//  ProgressBar1.Position := 0;
//  FPending := CoNewService_Async.Create(ROMessage, FROIndyHTTPChannel_Websocket2);
//  FPending.Invoke_GetServerTime;

  //pending.QueryInterface(IROAsyncInterface, async);
  //for i := 0 to 100 do
    //while not async.AnswerReceived do  does not work because some data is received...
  //  CheckSynchronize(100);
  RORemoteService.Channel := FROIndyHTTPChannel_Websocket2;
  btnServertime.Caption   := DateTimeToStr(
     (RORemoteService as INewService).GetServerTime);
end;

{
procedure TClientForm.CustomDataReceived(aData: TMemoryStream);
var
  s: string;
begin
  with TStreamReader.Create(aData) do
  try
    s := ReadToEnd;
  finally
    Free;
  end;

  //update in mainthread
  TThread.Queue(nil,
    procedure
    begin
      btnServertime.Caption := s;
      ProgressBar1.StepIt;
    end);
end;
}

{
procedure TClientForm.ServerAfterAddConnection(Server: TCustomServer;
  aConnection: TCustomConnection);
begin
  if aConnection is TWebSocketCustomConnection then
  begin
    (aConnection as TWebSocketCustomConnection).OnReadFull      := WebSocketConnectionDataFull;
    (aConnection as TWebSocketCustomConnection).FullDataProcess := True;
  end;
end;

procedure TClientForm.WebSocketConnectionDataFull(
  aSender: TWebSocketCustomConnection; aCode: integer; aData: TMemoryStream);
var
  s: string;
begin
  with TStreamReader.Create(aData) do
    try
      s := ReadToEnd;
    finally
      Free;
    end;
end;
}

end.
